indexing

   description: "Class that gets stat structure through stat call."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"

deferred class

   ABSTRACT_STATUS_PATH


inherit

   ABSTRACT_STATUS

   PORTABLE_PATH
      rename
         portable_path as path
      end


feature {ABSTRACT_FILE_SYSTEM} -- creation

   make (a_path: STRING) is
      require
         valid_path: a_path /= Void
      do
         make_stat
         set_portable_path (a_path)
         refresh
      end


feature -- state change commands

   refresh is
         -- Refresh the cached status information
      local
         cpath: POINTER
      do
         cpath := sh.string_to_pointer (path)
         safe_call (abstract_stat (cpath, stat.ptr))
      end


feature {NONE} -- abstract API

   abstract_stat (a_path: POINTER; a_stat: POINTER): INTEGER is
         -- Gets information about a file
      require
         valid_stat_buffer: a_stat /= default_pointer
      deferred
      ensure
         -- Result = -1 implies errno.is_not_ok
      end


end -- class ABSTRACT_STATUS_PATH
