indexing

   description: "Describes Windows PROCESS_INFORMATION struct."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"


class

   WINDOWS_PROCESS_INFORMATION


inherit

   WINDOWS_BASE

   WAPI_WINDOWS


creation

   make


feature -- creation

   make is
      do
         create ppi.allocate_and_clear (posix_process_information_size)
      end


feature -- state

   pid, dwProcessId: INTEGER is
      do
         Result := posix_process_information_dwprocessid (ptr)
      end

   process_handle, hProcess: INTEGER is
      do
         Result := posix_process_information_hprocess (ptr)
      end

   thread_handle, hThread: INTEGER is
      do
         Result := posix_process_information_hthread (ptr)
      end


feature -- pointer to state

   ptr: POINTER is
      do
         Result := ppi.ptr
      end


feature {NONE} -- private state

   ppi: STDC_BUFFER


invariant

   have_ppi: ppi /= Void

end
